/*
题目：打印出杨辉三角形（要求打印出 10 行如下图）
1.程序分析：
1
1 1 
1 2 1 
1 3 3 1 
1 4 6 4 1 
1 5 10 10 5 1
*/

/*
思路: 杨辉三角有如下规律
1. 各行第一个数都是1
2.各行最后一个数都是1
3. 从第三行起，除第一个数和最后一个数为1外，其余各数都是上一行同列
和前一列两个数之和。即a[i][j] = a[i-1][j]+a[i-1][j-1],i为行数j为列数
*/

#include<stdio.h>
#define N 10

int main(){
    int i,j,a[N][N];
    for(i=0;i<N;i++){
        a[i][i] = 1; //使对角线元素的值都为1
        a[i][0] = 1; //使第一列元素的值都为1
    }
    //计算杨辉三角的值
    for(i=2;i<N;i++){
        for(j=1;j<=i-1;j++){
            a[i][j] = a[i-1][j] + a[i-1][j-1];
        }
    }
    //打印数组中的内容即可
    for(i=0;i<N;i++){
        for(j=0;j<=i;j++){
            printf("%6d", a[i][j]);
        }
        printf("\n");
    }
}